PCI_IOV_INIT(9)

NAME
PCI_IOV_INIT - enable SR-IOV on a PF device

SYNOPSIS
#include <sys/bus.h>
#include <sys/stdarg.h>
#include <sys/nv.h>
#include <dev/pci/pci_iov.h>
int
PCI_IOV_INIT(device_t dev, uint16_t num_vfs, const nvlist_t *pf_config);

DESCRIPTION
The PCI_IOV_INIT() method is called by the PCI Single-Root I/O Virtualization (SR-IOV) infrastructure when the user requests that SR-IOV be enabled on a Physical Function (PF). The number of Virtual Functions (VFs) that will be created is passed to this method in the num_vfs argument.

If the driver requested device-specific PF configuration parameters via a PF schema in its call to pci_iov_attach(9), those parameters will be available in the pf_config argument. All configuration parameters that were either set as required parameters or that had a default value set in the PF schema are guaranteed to be present in pf_config. Configuration parameters that were neither set as required nor were given a default value are optional and may or may not be present in pf_config. pf_config will not contain any configuration parameters that were not specified in the PF schema. All configuration parameters will have the correct type and are in the range of valid values specified in the schema.

If this method returns successfully, then this method will not be called again on the same device until after a call to PCI_IOV_UNINIT(9).

RETURN VALUES
Returns 0 on success, otherwise an appropriate error is returned. If this method returns an error then the SR-IOV configuration will be aborted and no VFs will be created.

SEE ALSO
nv(9), pci(9), PCI_IOV_ADD_VF(9), pci_iov_schema(9), PCI_IOV_UNINIT(9)

AUTHORS
This manual page was written by Ryan Stone <rstone@FreeBSD.org>.